package xidian.sl.action.admin;


import java.io.File;
import java.util.List;

import xidian.sl.base.BaseAction;
import xidian.sl.entity.Classes;
import xidian.sl.entity.StuInfor;
import xidian.sl.util.FileUtil;
import xidian.sl.util.PageUtil;

public class ClassesAction extends BaseAction{
	/**
	 * ༶
	 */
	private static final long serialVersionUID = 1L;
	private List<Classes> classesList_;
	private String classesName;					//༶
	private String classesRemarks;				//༶ע
	private String idStr;						//idַ
	private Classes classes;
	private int tagId;
	//excel,excelļ
	protected File uploadExcel;														//ļ
	protected String uploadExcelFileName;											//ļ,ǰ׺Ҫļͬ
	protected static String[] allowFileType = { "xls", "XLS", "xlsx", "XLSX" };     //ļ
	private List<StuInfor> stuInforList;
	/**	
	 * ȡ༶б
	 * */
	public String getClassesList(){
		totalRecord = classesService.getClassesNums(); 	
		System.out.println(totalRecord);
		PageUtil pageUtil = new PageUtil(currentPage, totalRecord);												
		totalPages = pageUtil.getTotalPages();
		classesList_ = classesService.getClassesList(pageUtil);
		return SUCCESS;
	}
	/**
	 * Ӱ༶
	 * */
	public String addClasses(){
		try{
			classesService.addClasses(classesName, classesRemarks);
			response = "{success:true,msg:'ϲѳɹд洢'}";
		}catch(Exception e){
			response = "{success:false,msg:'sorry洢ʧ'}";
			e.printStackTrace();
		}
		return SUCCESS;
	}
	/**
	 * ɾ
	 * */
	public String deleteClasses(){
		try{
			classesService.deleteClasses(idStr);
			response = "{success:true,msg:'ϲѳɹɾ'}";
		}catch(Exception e){
			response = "{success:false,msg:'sorryɾʧ'}";
			e.printStackTrace();
		}
		return SUCCESS;
	}
	/**
	 * ʾ޸
	 * */
	public String showUpdateClasses(){
		classes = classesService.getClassesById(tagId);
		return SUCCESS;
	}
	/**
	 * ޸
	 * */
	public String updateClasses(){
		try{
			classesService.updateClasses(tagId, classesName, classesRemarks);
			response = "{success:true,msg:'ϲѳɹ޸'}";
		}catch(Exception e){
			response = "{success:false,msg:'sorry޸ʧ'}";
			e.printStackTrace();
		}
		return SUCCESS;
	}
	/**
	 * Ӱ༶
	 * */
	public String batchAdd(){
		try{
			System.out.println(""+uploadExcelFileName+"ļ"+uploadExcel);
			if ((uploadExcelFileName == null) || (uploadExcelFileName.equals(""))) {
		        response = "{success:false,msg:'ļΪգ'}";
		    }
		    if (!(FileUtil.validateFileType(uploadExcelFileName, allowFileType))) {   		//validateFileTypeFileUtil,صbooleanֵ
		        response = "{success:false,msg:'ļͲȷ!'}";
		    }
		    classesExcelBatchInput.uploadStu(uploadExcel);									//ֻһexcelļ
		    response = "{success:true,msg:'"+classesExcelBatchInput.getFinalMsg()+"'}";		//õĻظ
		}catch (Exception e) {
			e.printStackTrace();
			response = "{success:false,msg:'sorry: ʧ'}";
		}
		return SUCCESS;
	}
	/**
	 * ȡ༶ѧ
	 * */
	public String getClassesStu(){
		stuInforList = stuInforService.getClassesStu(tagId);
		return SUCCESS;
	}
	
	
	public List<Classes> getClassesList_() {
		return classesList_;
	}
	public void setClassesList_(List<Classes> classesList) {
		classesList_ = classesList;
	}
	public String getClassesRemarks() {
		return classesRemarks;
	}
	public void setClassesRemarks(String classesRemarks) {
		this.classesRemarks = classesRemarks;
	}
	public String getClassesName() {
		return classesName;
	}
	public void setClassesName(String classesName) {
		this.classesName = classesName;
	}
	public String getIdStr() {
		return idStr;
	}
	public void setIdStr(String idStr) {
		this.idStr = idStr;
	}
	public Classes getClasses() {
		return classes;
	}
	public void setClasses(Classes classes) {
		this.classes = classes;
	}
	public int getTagId() {
		return tagId;
	}
	public void setTagId(int tagId) {
		this.tagId = tagId;
	}
	public File getUploadExcel() {
		return uploadExcel;
	}
	public void setUploadExcel(File uploadExcel) {
		this.uploadExcel = uploadExcel;
	}
	public String getUploadExcelFileName() {
		return uploadExcelFileName;
	}
	public void setUploadExcelFileName(String uploadExcelFileName) {
		this.uploadExcelFileName = uploadExcelFileName;
	}
	public List<StuInfor> getStuInforList() {
		return stuInforList;
	}
	public void setStuInforList(List<StuInfor> stuInforList) {
		this.stuInforList = stuInforList;
	}
	
}
