package xidian.sl.util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * ڸʽ
 * @author sl 2011-11-17
 *
 */
public class FormatDate {
	
	/**
	 * õǰϵͳ,ʽ:yyyy-mm-dd
	 * 
	 * @return
	 */
	public static String getCurrentDate(){
		
		return getFormatDate("yyyy-MM-dd");
	}
	/**
	 * 
	 * @return
	 */
	public static String getCurrentYear(){
		
		return getFormatDate("yyyy");
	}
	/**
	 * ·
	 */
	public static String getCurrentMonth(){
		return getFormatDate("MM");
	}
	/**
	 * ضʽ
	 * ʽ:
	 * yyyy-mm-dd
	 * @param formatString
	 * @return
	 */
	protected static String getFormatDate(String formatString){
		String currentDate="";
		SimpleDateFormat format1 = new SimpleDateFormat(formatString);
		currentDate = format1.format(new Date());
		return currentDate;
	}
	/**
	 * ʱʽʽ
	 * @return
	 */
	public static String getFormateDateAll(){
		return getFormatDate("yyyy-MM-dd HH:mm:ss");
	}
	/**
	 * ȡʱʽ
	 * @return
	 */
	public static String getFormateDateSimple(){
		return getFormatDate("yyyyMMddHHmmss");
	}
	/**
	 * ȡʱ
	 * @param d
	 * @param day
	 * @return
	 */
	public static Date getDateAfterDay(Date d, int day) {
		Calendar now = Calendar.getInstance();
		now.setTime(d);
		now.set(Calendar.DATE, now.get(Calendar.DATE) + day);
		return now.getTime();
	}
	/**
	 * ؼСʱʱ
	 * @param d
	 * @param hour
	 * @return
	 */
	public static Date getDateAfterHour(Date d,int hour){
		Calendar now = Calendar.getInstance();
		now.setTime(d);
		now.set(Calendar.HOUR, now.get(Calendar.HOUR) + hour);
		return now.getTime();
	}
	/**
	 * ؼӺĳʱ
	 * @param d
	 * @param minutes
	 * @return
	 */
	public static Date getDateAfterMinute(Date d,int minutes){
		Calendar now = Calendar.getInstance();
		now.setTime(d);
		now.set(Calendar.MINUTE, now.get(Calendar.MINUTE) + minutes);
		return now.getTime();
	}
	/**
	 * ȽڵĴС
	 * true date1date2ǰ
	 * false date1date2
	 * @param date1
	 * @param date2
	 * @return
	 */
	public static boolean dateCompare(Date date1,Date date2){
		boolean dateComPareFlag = true;
		if (date2.compareTo(date1) != 1) {
			dateComPareFlag = false; 
		}
		return dateComPareFlag;
	}
	/**
	 * ʱ֮
	 * @param startTime
	 * @param endTime
	 * @return
	 */
	public static long dateMinus(Date startTime,Date endTime){
		return endTime.getTime()-startTime.getTime();
	}
	
	//stringʱ
	public static String time(String startTime, String endTime) throws ParseException{
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");// ʽʱ   
		Date outdate = sdf.parse(endTime);    
		Date indate =  sdf.parse(startTime);    
		long totalhours = (outdate.getTime()-indate.getTime())/(1000*60*60);//ʱ   
		long totalminutes = (outdate.getTime()-indate.getTime())/(1000*60)-totalhours*60;//   
		long totalseconds = (outdate.getTime()-indate.getTime())/(1000)-totalminutes*60;//   
		String total_time = totalhours+"ʱ"+totalminutes+""+totalseconds+"";  
		return total_time;
	}
	
	//㿼Եʣʱ
	public static String examRemainTime(String startTime, String endTime) throws ParseException{
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");// ʽʱ   
		Date outdate = sdf.parse(endTime);    
		Date indate =  sdf.parse(startTime); 
		long totalminutes = (outdate.getTime()-indate.getTime())/(1000*60);//   
		long totalseconds = (outdate.getTime()-indate.getTime())/(1000)-totalminutes*60;//  
		String remainTime = totalminutes+ "#"+ totalseconds;
		return remainTime;
	}
	
	
}
