package xidian.sl.util.mail;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date; 
import java.util.List;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.Address; 
import javax.mail.BodyPart;
import javax.mail.Message; 
import javax.mail.MessagingException;
import javax.mail.Multipart; 
import javax.mail.Session; 
import javax.mail.Transport; 
import javax.mail.internet.InternetAddress; 
import javax.mail.internet.MimeBodyPart; 
import javax.mail.internet.MimeMessage; 
import javax.mail.internet.MimeMultipart; 
import javax.mail.internet.MimeUtility;

/**
 * ʼָ֧
 * @author WWF
 *
 */
public class MailSender  { 
	/**
	 * Ϣ
	 */
	public static String errorMessage="";
	
/** 
  * ʼ ֧ȺȺռ˵ַӢĵ";"Ÿ
  * @param mailInfo ͵ʼϢ 
  * @return Ƿͳɹ
  */ 
	public static void sendMail(MailSenderInfo mailInfo) { 
	  // жǷҪ֤ 
	  MyAuthenticator authenticator = null; 
	  Properties pro = mailInfo.getProperties();
  	  // Setup mail server
	  pro.put("mail.smtp.host", mailInfo.getMailServerHost());
      // Get session
	  pro.put("mail.smtp.auth", "true"); //֤ͨ

	  if (mailInfo.isValidate()) { 
	  // Ҫ֤򴴽һ֤ 
		authenticator = new MyAuthenticator(mailInfo.getUserName(), mailInfo.getPassword()); 
	  }
	  // ʼỰԺ֤һʼsession mailSession = Session.getDefaultInstance(props,sa);ĳmailSession = Session.getInstance(props,sa);´һsession,
	  Session sendMailSession = Session.getInstance(pro,authenticator); 
	  try { 
	  // sessionһʼϢ 
	  Message mailMessage = new MimeMessage(sendMailSession); 
	  // ʼߵַ 
	  Address from = new InternetAddress(mailInfo.getFromAddress()); 
	  // ʼϢķ 
	  mailMessage.setFrom(from); 
	  // ʼĽߵַõʼϢ ,ֶ֧ߣӢĵ";"
	  System.out.println("ַ mail = "+mailInfo.getToAddress());
	  String[] tos = mailInfo.getToAddress().split(";");
	  List<Address> addresses = new ArrayList<Address>();
	  for (String to : tos) {
		  if (!to.trim().equals("")) {
			  System.out.println(to);
			  Address toAddress = new InternetAddress(to.trim());
			  addresses.add(toAddress);
		}
	}
	  Address [] toAddresses = new Address[addresses.size()];
	  for (int i = 0; i < addresses.size(); i++) {
		toAddresses[i] = addresses.get(i);
	}
	  //Address to = new InternetAddress(mailInfo.getToAddress()); 
//	  Address [] toAddresses = (Address[]) addresses.toArray();
	  mailMessage.setRecipients(Message.RecipientType.TO,toAddresses); 
	  
	  if (mailInfo.isReceipt()) {
		mailMessage.setHeader("Disposition-Notification-To", "1");
	}
	  //ʼҪ
	  mailMessage.setHeader("Importance", "High");//  Ҫ    [High|Normal|Low]
	  // ʼϢ 
	  mailMessage.setSubject(mailInfo.getSubject()); 
	  // ʼϢ͵ʱ 
	  mailMessage.setSentDate(new Date()); 
	  // ʼϢҪ 
	  //String mailContent = mailInfo.getContent(); 
	  //mailMessage.setText(mailContent); 
	  
	  //
	  MimeBodyPart mimeBodyPart = new MimeBodyPart();
	  /*mimeBodyPart.setText(mailContent);
	  Multipart multipart = new MimeMultipart();
	  multipart.addBodyPart(mimeBodyPart);*/
	  
	  Multipart multipart = new MimeMultipart(); 
	  // һHTMLݵMimeBodyPart 
	  BodyPart html = new MimeBodyPart(); 
	  // HTML 
	  html.setContent(mailInfo.getContent(), "text/html; charset=utf-8"); 
	  multipart.addBodyPart(html); 
	  // MiniMultipartΪʼ 
	  mailMessage.setContent(multipart); 
	  
	  
	  //Ӹֶ֧
	  List<String> attachFileNames = mailInfo.getAttachFileNames();
	  if (attachFileNames!=null) {
		  if (attachFileNames.size()>0) {
			  for (String string : attachFileNames) {
				  mimeBodyPart = new MimeBodyPart();
				  DataSource source = new FileDataSource(string);
				  mimeBodyPart.setDataHandler(new DataHandler(source));
				  //ļֹ
				  try {
					mimeBodyPart.setFileName(MimeUtility.encodeText(string));
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				  multipart.addBodyPart(mimeBodyPart);
			  }
		}
	  }
	
	  
	  mailMessage.setContent(multipart);
	  
	  // ʼ 
	  Transport.send(mailMessage);
	  } catch (Exception ex) { 
		  errorMessage = ex.getMessage();
		  ex.printStackTrace(); 
	  } 
	} 
	
	/**
	 * HTMLʽʼ
	 * @param mailInfo ͵ʼϢ
	 */
	public static boolean sendHtmlMail(MailSenderInfo mailInfo) {
		// жǷҪ֤
		MyAuthenticator authenticator = null;
		Properties pro = mailInfo.getProperties();
		pro.put("mail.smtp.host", mailInfo.getMailServerHost());
		pro.put("mail.smtp.auth", "true"); //֤ͨ
		// Ҫ֤򴴽һ֤
		if (mailInfo.isValidate()) {
			authenticator = new MyAuthenticator(mailInfo.getUserName(),mailInfo.getPassword());
		}
		// ʼỰԺ֤һʼsession
		Session sendMailSession = Session.getDefaultInstance(pro, authenticator);
		//
//		sendMailSession.setDebug(true);
		try {
			// sessionһʼϢ
			Message mailMessage = new MimeMessage(sendMailSession);
			// ʼߵַ
			Address from = new InternetAddress(mailInfo.getFromAddress());
			// ʼϢķ
			mailMessage.setFrom(from);
			// ʼĽߵַõʼϢУֶ֧˽
			String[] tos = mailInfo.getToAddress().split(";");
			List<Address> addresses = new ArrayList<Address>();
			for (String to : tos) {
				if (!to.trim().equals("")) {
					System.out.println(to);
					Address toAddress = new InternetAddress(to.trim());
					addresses.add(toAddress);
				}
			}
			Address[] toAddresses = new Address[addresses.size()];
			for (int i = 0; i < addresses.size(); i++) {
				toAddresses[i] = addresses.get(i);
			}
			// Address to = new InternetAddress(mailInfo.getToAddress());
			// Address [] toAddresses = (Address[]) addresses.toArray();
			mailMessage.setRecipients(Message.RecipientType.TO, toAddresses);
			
			if (mailInfo.isReceipt()) {
				mailMessage.setHeader("Disposition-Notification-To", "1");
			}
			
			// ʼϢ
			mailMessage.setSubject(mailInfo.getSubject());
			// ʼϢ͵ʱ
			mailMessage.setSentDate(new Date());
			// MiniMultipartһ࣬MimeBodyPart͵Ķ
			Multipart mainPart = new MimeMultipart();
			// һHTMLݵMimeBodyPart
			MimeBodyPart html = new MimeBodyPart();
			// HTML
			html.setContent(mailInfo.getContent(), "text/html; charset=utf-8");
			mainPart.addBodyPart(html);
			
			// Ӹֶ֧
			List<String> attachFileNames = mailInfo.getAttachFileNames();
			if (attachFileNames != null) {
				if (attachFileNames.size() > 0) {
					for (String string : attachFileNames) {
						MimeBodyPart mimeBodyPart = new MimeBodyPart();
						DataSource source = new FileDataSource(string);
						mimeBodyPart.setDataHandler(new DataHandler(source));
						// ļֹ
						try {
							mimeBodyPart.setFileName(MimeUtility.encodeText(string));
						} catch (UnsupportedEncodingException e) {
							e.printStackTrace();
						}
						mainPart.addBodyPart(mimeBodyPart);
					}
				}
			}
			
			// MiniMultipartΪʼ
			mailMessage.setContent(mainPart);
			// ʼ
			Transport.send(mailMessage);
			return true;
		} catch (MessagingException ex) {
			ex.printStackTrace();
		}
		return false;
	}

}