package xidian.sl.action.admin;

import java.io.File;
import java.util.List;

import xidian.sl.base.BaseAction;
import xidian.sl.entity.Major;
import xidian.sl.util.FileUtil;
import xidian.sl.util.PageUtil;

public class MajorAction extends BaseAction{
	/**
	 * רҵĴ
	 */
	private static final long serialVersionUID = 1L;
	private List<Major> majorList_;
	private String majorName;
	private String majorRemark;
	private String idStr;
	private Major major;
	private Integer tagId;
	//excel,excelļ
	protected File uploadExcel;														//ļ
	protected String uploadExcelFileName;											//ļ,ǰ׺Ҫļͬ
	protected static String[] allowFileType = { "xls", "XLS", "xlsx", "XLSX" };     //ļ
	/**
	 * ȡרҵб
	 * */
	public String getMajorList(){
		totalRecord = majorService.getMajorNums(); 		
		PageUtil pageUtil = new PageUtil(currentPage, totalRecord);												
		totalPages = pageUtil.getTotalPages();
		majorList_ = majorService.getMajorList(pageUtil);
		return SUCCESS;
	}
	/**
	 * רҵ
	 * */
	public String addMajor(){
		try{
			System.out.println(""+majorName);
			majorService.addMajor(majorName, majorRemark);
			response = "{success:true,msg:'ϲѳɹд洢'}";
		}catch(Exception e){
			response = "{success:false,msg:'sorry洢ʧ'}";
			e.printStackTrace();
		}
		return SUCCESS;
	}
	
	/**
	 * ɾ
	 * */
	public String deleteMajor(){
		try{
			majorService.deleteMajor(idStr);
			response = "{success:true,msg:'ϲѳɹɾ'}";
		}catch(Exception e){
			response = "{success:false,msg:'sorryɾʧ'}";
			e.printStackTrace();
		}
		return SUCCESS;
	}
	
	/**
	 * ʾ޸
	 * */
	public String showUpdateMajor(){
		major = majorService.getMajorById(tagId);
		return SUCCESS;
	}
	/**
	 * ޸
	 * */
	public String updateMajor(){
		try{
			majorService.updateMajor(tagId, majorName, majorRemark);
			response = "{success:true,msg:'ϲѳɹ޸'}";
		}catch(Exception e){
			response = "{success:false,msg:'sorry޸ʧ'}";
			e.printStackTrace();
		}
		return SUCCESS;
	}
	/**
	 * Ӱ༶
	 * */
	public String batchAdd(){
		try{
			if ((uploadExcelFileName == null) || (uploadExcelFileName.equals(""))) {
		        response = "{success:false,msg:'ļΪգ'}";
		    }
		    if (!(FileUtil.validateFileType(uploadExcelFileName, allowFileType))) {   		//validateFileTypeFileUtil,صbooleanֵ
		        response = "{success:false,msg:'ļͲȷ!'}";
		    }
		    majorExcelBatchInput.uploadStu(uploadExcel);									//ֻһexcelļ
		    response = "{success:true,msg:'"+majorExcelBatchInput.getFinalMsg()+"'}";		//õĻظ
		}catch (Exception e) {
			e.printStackTrace();
			response = "{success:false,msg:'sorry: ʧ'}";
		}
		return SUCCESS;
	}
	
	public List<Major> getMajorList_() {
		return majorList_;
	}
	public void setMajorList_(List<Major> majorList) {
		majorList_ = majorList;
	}
	public String getMajorName() {
		return majorName;
	}
	public void setMajorName(String majorName) {
		this.majorName = majorName;
	}
	public String getMajorRemark() {
		return majorRemark;
	}
	public void setMajorRemark(String majorRemark) {
		this.majorRemark = majorRemark;
	}
	public String getIdStr() {
		return idStr;
	}
	public void setIdStr(String idStr) {
		this.idStr = idStr;
	}
	public File getUploadExcel() {
		return uploadExcel;
	}
	public void setUploadExcel(File uploadExcel) {
		this.uploadExcel = uploadExcel;
	}
	public String getUploadExcelFileName() {
		return uploadExcelFileName;
	}
	public void setUploadExcelFileName(String uploadExcelFileName) {
		this.uploadExcelFileName = uploadExcelFileName;
	}
	public Major getMajor() {
		return major;
	}
	public void setMajor(Major major) {
		this.major = major;
	}
	public Integer getTagId() {
		return tagId;
	}
	public void setTagId(Integer tagId) {
		this.tagId = tagId;
	}
	
}
