package xidian.sl.action.admin;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.ServletActionContext;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;

import xidian.sl.base.BaseAction;
import xidian.sl.entity.OperateLog;
import xidian.sl.entity.StuInfor;
import xidian.sl.util.Unzip;

public class ToolAction extends BaseAction implements ServletResponseAware,ServletRequestAware{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private List<StuInfor> stuInforList;
	private static String[] prefixs = {".jpg", ".png", ".gif"};
	private String response;
	private File upload;
	private String uploadContentType;
	private String uploadFileName;
	private static final int BUFFER_SIZE = 16 * 1024 ;
	private List<OperateLog> operateLogList;
	protected javax.servlet.http.HttpServletResponse responseTrue;
	protected javax.servlet.http.HttpServletRequest request;
	
	@Override
	public String execute() throws Exception {
		return SUCCESS;
	}
	/**
	 * ʾƬɸѡ
	 * */
	public String showSelect(){
		stuInforList = stuInforService.getStuInforList();
		return SUCCESS;
	}
	/**
	 * Ƭɸѡ
	 * @throws FileNotFoundException 
	 * */
	public String select() throws FileNotFoundException{
		try{
			String newPath = ServletActionContext.getServletContext().getRealPath("/stuPhoto");;
			showSelect();
			//ɸѡϴ
			GetSelectFileName(newPath, stuInforList, prefixs);
			response = "{success:true}";
		}catch (Exception e) {
			System.out.println("ɸѡʧ");
			response = "{success:false}";
		}
		
		
		return SUCCESS;
	}
	
	/**
	 * @param fileAbsolutePath ҪļĿ¼
	 * @param newFilePath ŷļ·
	 * @param selectName ͼƬ[ΪУѶ󼯺]
	 * @param prefixs ϱĺ׺
	 * @throws FileNotFoundException 
	 * 
	 * 
	 * */
    public void GetSelectFileName(String newFilePath, List<StuInfor> selectName, String[] prefixs) throws FileNotFoundException
    {
         //File file = new File(fileAbsolutePath);
    	String path = ServletActionContext.getServletContext().getRealPath("uploadPhoto");
    	//File file = new File(path+"/"+fileAbsolutePath);
    	File file = new File(path);
         //ļڵļ
         File[] subFile = file.listFiles();
         //еļб
         for (int iFileLength = 0; iFileLength < subFile.length; iFileLength++)
         {
             //жǷΪļ
             if (!subFile[iFileLength].isDirectory())
             {
                 String tempName = subFile[iFileLength].getName();
                 //жϸļǷչ
                 for(int prefixLength = 0; prefixLength < prefixs.length; prefixLength++){
                	 //ָĺ׺
                	 if(tempName.toLowerCase().endsWith(prefixs[prefixLength])){
                		 String[] tempNameSplit = tempName.split("\\.");
                		 //ǷɸѡҪ
                		 for(StuInfor name: selectName){
                			 if (name.getStuSfzh().equals(tempNameSplit[0]))
                             {
                				 System.out.println("ɸѡ֤ = "+name.getStuSfzh());
                				 //ļһָļ
                				 Copy(path+"/"+tempName, newFilePath);
                				 //ݿĴ洢
                				 savePhoto(name.getStuSfzh(), "stuPhoto/"+tempName);
                             }
                		 }
                     }
                 }
             }
         }
    }
    /**
     * ķʽļĸ
     * */
    public void Copy(String oldPath, String newPath)  
    {  
    try {  
	    int bytesum = 0;  
	    int byteread = 0;
	    File newFile = new File(newPath);
	    if(!newFile.exists()){
	    	newFile.mkdirs();
	    }
	    File oldfile = new File(oldPath);  
	    if (oldfile.exists()) {  
		    InputStream is = new FileInputStream(oldPath);  
		    
		    FileOutputStream fs = new FileOutputStream(newPath+"/"+oldfile.getName());  
		    byte[] buffer = new byte[1444];  
		    while ((byteread = is.read(buffer)) != -1) {  
			    bytesum += byteread;  
			    System.out.println(bytesum);  
			    fs.write(buffer, 0, byteread);  
		    }  
		    is.close();
		    fs.close();
	    }  
    }  
    catch (Exception e) {  
	    System.out.println( "error ");  
	    e.printStackTrace();  
    	}  
    }
    /**
     * ļϴ
     * @throws IOException 
     * */
    public String uploadFile() throws IOException{
    	responseTrue.setCharacterEncoding("UTF-8");
    	responseTrue.setContentType("text/html;charset= UTF-8");
		PrintWriter outTrue = responseTrue.getWriter();
    	System.out.println("õĴ");
    	try {
			String path = ServletActionContext.getServletContext().getRealPath("uploadPhoto");
			File directory = new File(path);
			if (!directory.exists()) {
				directory.mkdir();
			}
			String dbSavePath = path + "/" + getUploadFileName();
			BufferedOutputStream out = null;
			BufferedInputStream in = null;
			try {
				in = new BufferedInputStream(new FileInputStream(getUpload()),
						BUFFER_SIZE);
				out = new BufferedOutputStream(new FileOutputStream(new File(
						dbSavePath)), BUFFER_SIZE);
				byte[] buffer = new byte[BUFFER_SIZE];
				while (in.read(buffer) > 0) {
					out.write(buffer);
				}
				System.out.println("·"+dbSavePath);
				//нѹ
				Unzip.unZip(dbSavePath);
				out.flush();
			} finally {
				if (null != in) {
					in.close();
				}
				if (null != out) {
					out.close();
				}
			}
			//response = "{\"success\":true,\"msg\":\"ϲϴɹ\"}";
			outTrue.println("<script>parent.callback('ϴɹ')</script>"); 
		}catch (Exception e) {
			e.printStackTrace();
			//response = "{\"success\":false,\"msg\":\"sorryʧܣϴ\"}";
			outTrue.println("<script>parent.callback('ϴʧ')</script>"); 
		}
		return null;
    }
    
    
    public void savePhoto(String sfzh, String stuPhotoPath){
    	StuInfor stuInfor = stuInforService.getInforBySfz(sfzh);
    	stuInfor.setStuPhotoPath(stuPhotoPath);
    	stuInforService.update(stuInfor);
    	System.out.println("ɹ");
    }
    
    /**
     * ȡ־Ϣ
     * */
    public String logList(){
    	operateLogList = commonService.findAll(OperateLog.class);
    	return SUCCESS;
    }
    
    
	public List<StuInfor> getStuInforList() {
		return stuInforList;
	}
	public String getResponse() {
		return response;
	}
	public File getUpload() {
		return upload;
	}
	public void setUpload(File upload) {
		this.upload = upload;
	}
	public String getUploadContentType() {
		return uploadContentType;
	}
	public void setUploadContentType(String uploadContentType) {
		this.uploadContentType = uploadContentType;
	}
	public String getUploadFileName() {
		return uploadFileName;
	}
	public void setUploadFileName(String uploadFileName) {
		this.uploadFileName = uploadFileName;
	}
	@Override
	public void setServletResponse(HttpServletResponse response) {
		this.responseTrue = response;
		
	}
	@Override
	public void setServletRequest(HttpServletRequest request) {
		this.request = request;
		
	}
	public List<OperateLog> getOperateLogList() {
		return operateLogList;
	}
	public void setOperateLogList(List<OperateLog> operateLogList) {
		this.operateLogList = operateLogList;
	}
    
}
