package xidian.sl.action.survey;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import xidian.sl.base.BaseAction;
import xidian.sl.entity.Admin;
import xidian.sl.entity.QueQuebank;
import xidian.sl.entity.QuestionBank;
import xidian.sl.entity.Questionnaire;
import xidian.sl.util.FormatDate;

import com.opensymphony.xwork2.ActionContext;

public class QuestionnaireAction extends BaseAction{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String title;
	private String describe;
	private String queStr;
	
	private List<Integer> queIdList = new ArrayList<Integer>();
	
	private List<Questionnaire> questionnaireList;
	private Integer questionnaireId;
	private Questionnaire questionnaire;
	private List<QuestionBank> questionBankList;
	
	/*ʾ*/
	public String addQuestionnaire(){
		try{
			Integer adminId = (Integer)ActionContext.getContext().getSession().get("userId");
			Admin admin = commonService.findById(Admin.class, adminId);
			//1.ȱʾĻϢ
			Questionnaire questionnaire = new Questionnaire();
			questionnaire.setQuestionnaireTitle(title);
			questionnaire.setQuestionnaireDes(describe);
			questionnaire.setAdmin(admin);
			questionnaire.setQueDate(FormatDate.getCurrentDate());
			commonService.sava(questionnaire);
			//2.ݸĿĳȡĿ
			String queryString = "";
			String[] queList = queStr.split("-");
			for (int i = 0; i < queList.length; i++) {
				if (!queList[i].equals("0")) {
					switch (i % 3) {
					case 0:								//ʾѡ
						//ݸĿȡ
						queryString = "select que.queId from QuestionBank as que where que.queType.typeName='ѡ'";
						break;
					case 1:								//ѡ
						queryString = "select que.queId from QuestionBank as que where que.queType.typeName='ѡ'";
						break;
					case 2:								//ʴ
						queryString = "select que.queId from QuestionBank as que where que.queType.typeName='ʴ'";
						break;
					}
					makeIdRandom(questionnaireService.getIdList(queryString), Integer.valueOf(queList[i]));
				}
			}
			//3.ѡⱣ浽ϵ
			for(int i = 0; i< queIdList.size(); i++){
				QueQuebank que = new QueQuebank();
				que.setQuestionBank(commonService.findById(QuestionBank.class, queIdList.get(i)));
				que.setQuestionnaire(questionnaire);
				commonService.sava(que);
			}
			response="{success:true,msg:'ӵʾɹ'}";
		}catch(Exception e){
			e.printStackTrace();
			response="{success:false,reason:'ӵʾʧ'}";
		}
		
		return SUCCESS;
	}
	
	//ȡѡ
	private void makeIdRandom(List<Integer> list,int subNum){
		Random random = new Random();
		for (int i = 0; i < subNum; ++i) {
	    	int rand = random.nextInt(list.size());		//nextInt 
	    	int tempId = list.get(rand);				//Ŀı
	    	queIdList.add(Integer.valueOf(tempId));
	    	list.remove(rand);
	    }
	}
	
	
	/*ʾб*/
	public String questionnaireList(){
		questionnaireList = commonService.findAll(Questionnaire.class);
		return SUCCESS;
	}
	
	/*ʾʾͼ*/
	public String questionnaireDetail(){
		//1.ʾϢ
		questionnaire = commonService.findById(Questionnaire.class, questionnaireId);
		//2.ʾĿ
		questionBankList = queBankService.getQueByQueId(questionnaireId);
		return SUCCESS;
	}
	
	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getDescribe() {
		return describe;
	}

	public void setDescribe(String describe) {
		this.describe = describe;
	}

	public String getQueStr() {
		return queStr;
	}

	public void setQueStr(String queStr) {
		this.queStr = queStr;
	}

	public List<Integer> getQueIdList() {
		return queIdList;
	}

	public void setQueIdList(List<Integer> queIdList) {
		this.queIdList = queIdList;
	}

	public List<Questionnaire> getQuestionnaireList() {
		return questionnaireList;
	}

	public void setQuestionnaireList(List<Questionnaire> questionnaireList) {
		this.questionnaireList = questionnaireList;
	}

	public Integer getQuestionnaireId() {
		return questionnaireId;
	}

	public void setQuestionnaireId(Integer questionnaireId) {
		this.questionnaireId = questionnaireId;
	}

	public Questionnaire getQuestionnaire() {
		return questionnaire;
	}

	public void setQuestionnaire(Questionnaire questionnaire) {
		this.questionnaire = questionnaire;
	}

	public List<QuestionBank> getQuestionBankList() {
		return questionBankList;
	}

	public void setQuestionBankList(List<QuestionBank> questionBankList) {
		this.questionBankList = questionBankList;
	}
	
	
}
