package xidian.sl.dao.admin;

import java.util.List;
/**
 *
 * @param <T>
 */

public interface GenericDAO <T>{
	/**
	 * ͨIDʵ
	 * 
	 * @param idʵıʶ
	 * @return ֵӦʵ
	 */
	T findById(int id);
	
	/**
	 * ʵ־û
	 * 
	 * @param entity Ҫг־ûʵ
	 * @return ־ûʵ
	 */
	T makePersitent(T entity); 
	
	/**
	 * ʵΪ˲̬,ʾɾ
	 * 
	 * @param entityҪתΪ˲̬ʵ
	 */
	void makeTransient(T entity);
	
	/**
	 * һϵеʵΪ˲̬ʹñsql
	 * 
	 * @param hql
	 */
	void makeTransientByIds(String sql);
	
	/**
	 * 
	 * ʹhqlзҳ
	 * 
	 * @param hql	
	 * @param offset	һ¼
	 * @param pageSize	ÿҳҪʾļ¼
	 * @return	ѯļ¼
	 */
	List<T> findByPage(final String hql,final int offset,final int pageSize);
	
	
	/**
	 * ʹhql зҳѯ
	 * 
	 * @param hql Ҫѯhql
	 * @param value hqlһҪ룬valueǴĲ
	 * @param offset һ¼
	 * @param pageSize ÿҳҪʾļ¼
	 * @return ǰҳм¼
	 */
	List<T> findByPage(final String hql , final Object value ,
			 final int offset, final int pageSize);
	
	/**
	 * ʹhql зҳѯ
	 * 
	 * @param hql Ҫѯhql
	 * @param values hqlһҪ룬valueǴĲ
	 * @param offset һ¼
	 * @param pageSize ÿҳҪʾļ¼
	 * @return ǰҳм¼
	 */
	List<T> findByPage(final String hql, final Object[] values,
			 final int offset, final int pageSize);
	

	/**
	 * ʹsql зҳѯ
	 * 
	 * @param sql
	 * @param offset
	 * @param pageSize
	 * @return
	 */
	List<T> findByPageSQL(final String sql, 
			 final int offset, final int pageSize);
	
	/**
	 * 
	 * @param hql hql
	 * @return ӦĿ
	 */
	Integer getCount(String hql);
	
	
	void updateObj(final String hql,final Object[] values);
	
	/**
	 * ݶ
	 * */
	void updateEntity(T entity);
	/**
	 * HQLѯҳ
	 * */
	List<T> findListByHQL(String hql);
}
