package xidian.sl.service.impl.admin;

import java.util.List;

import xidian.sl.dao.admin.AdminDAO;
import xidian.sl.entity.Admin;
import xidian.sl.service.admin.AdminService;

public class AdminServiceImpl implements AdminService{
	private AdminDAO adminDAO;
	
	public AdminDAO getAdminDAO() {
		return adminDAO;
	}
	public void setAdminDAO(AdminDAO adminDAO) {
		this.adminDAO = adminDAO;
	}
	@Override
	public List<Admin> getList() {
		String hql = "from Admin as ad where ad.adminRight = 'ͨԱ'";
		return adminDAO.findListByHQL(hql);
	}
	
	@Override
	public void addAdmin(String adminNum, String adminPw, String idStr) {
		Admin admin = new Admin();
		admin.setAdminNum(adminNum);
		admin.setAdminPw(adminPw);
		admin.setManageRange(idStr);
		admin.setAdminRight("ͨԱ");
		adminDAO.makePersitent(admin);
	}
	@Override
	public void delete(String idStr) {
		String[] ids = idStr.split("-");
		for(String id: ids){
			adminDAO.makeTransient(adminDAO.findById(Integer.valueOf(id)));
		}
	}
	@Override
	public Admin getAdminById(int id) {
		return adminDAO.findById(id);
	}
	@Override
	public void update(int id, String adminNum, String adminPw) {
		Admin admin = adminDAO.findById(id);
		admin.setAdminNum(adminNum);
		admin.setAdminPw(adminPw);
		admin.setAdminRight("ͨԱ");
		adminDAO.updateEntity(admin);
	}
	
	
}	
