package xidian.sl.service.impl.admin;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.List;

import jxl.Cell;
import jxl.CellType;
import jxl.DateCell;
import jxl.LabelCell;
import jxl.Sheet;
import jxl.Workbook;
import xidian.sl.dao.admin.ClassesDAO;
import xidian.sl.entity.Classes;
import xidian.sl.service.admin.ExcelBatchInput;
/**
 * jxlȷʵкܶ෽⣬֧xlsx
 * д
 * ڽexcelʱǶ༸е
 * */
public class ClassesExcelBatchInputImpl implements ExcelBatchInput {
	private Sheet sheet;
	private String[][] excelValue;
	private int successRow;
	private int failRow;
	private StringBuilder msg=new StringBuilder();
	private String finalMsg;
	private ClassesDAO classesDAO;
	
	/**
	 * excelܷ
	 */
	public String uploadStu(File upload) {
		System.out.println("༶ϴ");
		initExcel(upload);		//ʼ
		readExcel();			//ȡ
		insertIntoDB();	        //
		return msg.toString();
	}
	/**
	 * ȡexcelļݣ浽sheet
	 * @param upload
	 */
	private void initExcel(File upload) {
	    Workbook rwb = null;
	    try {
	    	InputStream is = new FileInputStream(upload);
	    	rwb = Workbook.getWorkbook(is);

	    	sheet = rwb.getSheet(0);
	    } 	catch (Exception e) {
	    	e.printStackTrace();
	    }
	}
	/**
	 * ȡexcelݽexcelValue
	 */
	private void readExcel(){
		excelValue = new String[sheet.getRows()][sheet.getColumns()];
	    for (int i = 0; i < sheet.getRows(); i++)
	    	for (int j = 0; j < sheet.getColumns(); j++) {
	    		Cell cell = sheet.getCell(j, i);
	    		if ("".equals(cell.getContents().toString().trim())){
	    			excelValue[i][j] = "";
	    		}
	    		if (cell.getType() == CellType.LABEL) {
	    			LabelCell labelcell = (LabelCell)cell;
	    			excelValue[i][j] = labelcell.getString().trim();
	    		} else if (cell.getType() == CellType.NUMBER){
	    			excelValue[i][j] = cell.getContents();
	    		} else if (cell.getType() == CellType.DATE) {
	    			DateCell datcell = (DateCell)cell;
	    			excelValue[i][j] = datcell.getDate().toString();
	    		} else {
	    			excelValue[i][j] = cell.getContents().toString().trim();
	    		}
	      }
	  }
	
	/**
	  * 3.ݿ
	  * @param course
	  */
	private void insertIntoDB() {
		int excelRows = excelValue.length;
		//Ϣ
		msg.delete(0, msg.length());
		finalMsg = "";
		successRow = 0;
		failRow = 0;
	    if (excelValue.length > 1) {
	    	for (int i = 1; i < excelRows; i++) {		//ӵڶſʼһΪ˵
	    		String[] DBValue = excelValue[i];		//ȡһ
	    		if(DBValue[0] != ""){
	    			if (validateInfor(i,DBValue)){
		    			successRow += 1;
		    			finalInsert(DBValue);
		    		} else {
		    			failRow += 1;
		    		}
	    		}
	    	}
	    		finalMsg = "¼ɹ"+"</br>"+"Ŀ굼༶"+(successRow+failRow)+"</br>"
				+"ɹ¼"+(successRow)+"</br>"
				+"ʧ¼"+(failRow)+"</br>"
				+msg.toString();
	    	System.out.println(finalMsg);
	    } else {
	    	finalMsg = "excelκݣ";
	    	System.out.println("excelûκ");
	    }
	}
	
	//շؼ
	private boolean validateInfor(int i,String[] DBValue){
		Boolean bol=true;
		if(!(validateNumRepeat(i,DBValue))){
			bol=false;
		}
		return bol;
	}
	
	//֤λǷظ
	private boolean validateNumRepeat(int i,String[] DBValue){
		boolean bolValidate=true;
		/**
		 * ҪѧǷظ
		 * ҪĽΪÿһͻһݿ
		 * */
		String hql = "from Classes";
		List<Classes> classesList = classesDAO.findListByHQL(hql);
		for(Classes classes: classesList){
			if(classes.getClassesName().equals(DBValue[0]) && DBValue[0]!=""){
				bolValidate=false;
				msg.append("Ϣ"+i+"༶ݿѴ洢ظ,["+DBValue[0]+"],飡</br>");
				return bolValidate;
			}
		}
		return bolValidate;
	}
	
	
	//ղ,Ҫ޸
	private void finalInsert(String[] DBValue){
		Classes classes = new Classes();
		classes.setClassesName(DBValue[0]);
		classes.setClassesRemarks(DBValue[1]);
		classesDAO.makePersitent(classes);
	}
	
	
	public Sheet getSheet() {
		return sheet;
	}
	public void setSheet(Sheet sheet) {
		this.sheet = sheet;
	}
	public String[][] getExcelValue() {
		return excelValue;
	}
	public void setExcelValue(String[][] excelValue) {
		this.excelValue = excelValue;
	}
	public int getSuccessRow() {
		return successRow;
	}
	public void setSuccessRow(int successRow) {
		this.successRow = successRow;
	}
	public int getFailRow() {
		return failRow;
	}
	public void setFailRow(int failRow) {
		this.failRow = failRow;
	}
	public StringBuilder getMsg() {
		return msg;
	}
	public void setMsg(StringBuilder msg) {
		this.msg = msg;
	}
	public String getFinalMsg() {
		return finalMsg;
	}
	public void setFinalMsg(String finalMsg) {
		this.finalMsg = finalMsg;
	}
	public ClassesDAO getClassesDAO() {
		return classesDAO;
	}
	public void setClassesDAO(ClassesDAO classesDAO) {
		this.classesDAO = classesDAO;
	}
}
