package xidian.sl.service.impl.admin;

import java.util.HashMap;
import java.util.Map;

import xidian.sl.action.exception.NameNotFoundException;
import xidian.sl.action.exception.PwNotMatchException;
import xidian.sl.dao.admin.AdminDAO;
import xidian.sl.dao.admin.StuInforDAO;
import xidian.sl.entity.Admin;
import xidian.sl.entity.StuInfor;
import xidian.sl.service.admin.LoginService;

public class LoginServiceImpl implements LoginService {
	private AdminDAO adminDAO;
	private StuInforDAO stuInforDAO;
	@SuppressWarnings("unchecked")
	@Override
	public Map adminLogin(String admName, String admPsw, Integer userType)
			throws NameNotFoundException, PwNotMatchException {
		System.out.println("û   = "+admName + admPsw+ userType);
		if(userType == 0){									//ʾ½ǹԱ
			Admin admin = adminDAO.findAdminByName(admName);
			if(admin == null){
				throw new NameNotFoundException();
			}else if(!(admin.getAdminPw()).equals(admPsw)){
				throw new PwNotMatchException();
			}else{
				Map map=new HashMap();
				map.put("adminName", admin.getAdminNum());
				//־ʹ
				map.put("userId", admin.getAdminId());
				map.put("admin", admin);
				map.put("adminType", admin.getAdminRight());
				return map;
			}
		}else if(userType == 1){
			StuInfor stuInfor = stuInforDAO.getStuInforByNum(admName);
			if(stuInfor == null){
				throw new NameNotFoundException();
			}else if(!(stuInfor.getPassword()).equals(admPsw)){
				throw new PwNotMatchException();
			}else{
				Map map=new HashMap();
				map.put("adminName", stuInfor.getStuName());
				map.put("userId", stuInfor.getStuId());
				map.put("adminNum", stuInfor.getStuNum());
				map.put("adminType", stuInfor.getStuType());
				return map;
			}
		}
		return null;
	}

	@Override
	public void updateAdmin(Admin admin) {
		adminDAO.updateEntity(admin);
	}

	public AdminDAO getAdminDAO() {
		return adminDAO;
	}

	public void setAdminDAO(AdminDAO adminDAO) {
		this.adminDAO = adminDAO;
	}

	public StuInforDAO getStuInforDAO() {
		return stuInforDAO;
	}

	public void setStuInforDAO(StuInforDAO stuInforDAO) {
		this.stuInforDAO = stuInforDAO;
	}
	
	
}
